【POJ】2151:Check the difficulty of problems【概率DP】

时间:2023-03-09 19:56:41
【POJ】2151:Check the difficulty of problems【概率DP】
Check the difficulty of problems
Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 8903   Accepted: 3772

Description

Organizing a programming contest is not an easy job. To avoid making the problems too difficult, the organizer usually expect the contest result satisfy the following two terms: 
1. All of the teams solve at least one problem. 
2. The champion (One of those teams that solve the most problems) solves at least a certain number of problems.

Now the organizer has studied out the contest problems, and through the result of preliminary contest, the organizer can estimate the probability that a certain team can successfully solve a certain problem.

Given the number of contest problems M, the number of teams T, and the number of problems N that the organizer expect the champion solve at least. We also assume that team i solves problem j with the probability Pij (1 <= i <= T, 1<= j <= M). Well, can you calculate the probability that all of the teams solve at least one problem, and at the same time the champion team solves at least N problems?

Input

The input consists of several test cases. The first line of each test case contains three integers M (0 < M <= 30), T (1 < T <= 1000) and N (0 < N <= M). Each of the following T lines contains M floating-point numbers in the range of [0,1]. In these T lines, the j-th number in the i-th line is just Pij. A test case of M = T = N = 0 indicates the end of input, and should not be processed.

Output

For each test case, please output the answer in a separate line. The result should be rounded to three digits after the decimal point.

Sample Input

2 2 2
0.9 0.9
1 0.9
0 0 0

Sample Output

0.972

Source

POJ Monthly,鲁小石

Solution

概率DP

定义$dp[i][j][k]$表示第$i$个队伍做了$j$道题对了$k$道的概率。转移方程显然。

再定义$s[i][j]$表示第$i$个队对了不超过$j$道题的概率,$s[i][j]=\sum{dp[i][t][k]},0<=k<=j$

然后所有队伍都对了至少一道题的概率就是$p1=\prod{(1-s[i][0])}$

因为冠军队至少对了$n$道,那么最后的概率应该是$p1$减去每个队伍都没有达到$n$的概率:$\prod{s[i][n-1]}$,在这里要注意,还要保证每个队伍都至少对了1道题,因为是递推转移得到$s$,不能把$0$的贡献算进去,所以$s$从2开始递推。

Code

#include<iostream>
#include<cstdio>
using namespace std; double dp[][][], s[][], p[][];
int m, t, n; int main() {
while(scanf("%d%d%d", &m, &t, &n) != EOF) {
if(m == && t == && n == ) break;
for(int i = ; i <= t; i ++)
for(int j = ; j <= m; j ++)
scanf("%lf", &p[i][j]);
for(int i = ; i <= t; i ++) {
dp[i][][] = ;
for(int j = ; j <= m; j ++) {
dp[i][j][] = dp[i][j - ][] * ( - p[i][j]);
for(int k = ; k <= j; k ++)
dp[i][j][k] = dp[i][j - ][k - ] * p[i][j] + dp[i][j - ][k] * ( - p[i][j]);
}
for(int j = ; j <= m; j ++)
s[i][j] = dp[i][m][j];
}
for(int i = ; i <= t; i ++)
for(int j = ; j <= m; j ++)
s[i][j] = s[i][j] + s[i][j - ];
double p1 = ;
for(int i = ; i <= t; i ++) p1 *= ( - s[i][]);
double p2 = ;
for(int i = ; i <= t; i ++) p2 *= s[i][n - ];
if(n == ) p2 = ;
printf("%0.3lf\n", p1 - p2);
}
return ;
}